#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#tryinclude <biohazard>

#if !defined _biohazard_included
        #assert Biohazard functions file required!
#endif

new g_primweaponnames[][] = 
{ 
	"weapon_m4a1", 
	"weapon_ak47", 
	"weapon_aug", 
	"weapon_sg552", 
	"weapon_galil", 
	"weapon_famas", 
	"weapon_m249", 
	"weapon_mp5navy", 
	"weapon_xm1014", 
	"weapon_m3",
	"weapon_p90", 
	"weapon_sg550", 
	"weapon_g3sg1" 					
}

new g_secweaponnames[][] = 
{
	"weapon_deagle", 
	"weapon_usp", 
	"weapon_elite" 					
}

new g_grenades[][] = 
{ 
	"weapon_hegrenade",
	"weapon_flashbang",
	"weapon_smokegrenade"
}


#define MAX_AMMO 200
#define TASKID_SPAWNDELAY   523

#define OFFSET_AMMO_AWP 	377
#define OFFSET_AMMO_SCOUT 	378
#define OFFSET_AMMO_M249 	379
#define OFFSET_AMMO_FAMAS 	380
#define OFFSET_AMMO_M3 		381
#define OFFSET_AMMO_USP 	382
#define OFFSET_AMMO_FIVESEVEN 	383
#define OFFSET_AMMO_DEAGLE 	384
#define OFFSET_AMMO_P228 	385
#define OFFSET_AMMO_GLOCK18 	386

#define PRIMARY_WEAPONS (1<<CSW_AK47 | 1<<CSW_AUG | 1<<CSW_AWP | 1<<CSW_FAMAS | 1<<CSW_G3SG1 | 1<<CSW_GALIL | 1<<CSW_M249 | 1<<CSW_M3 | 1<<CSW_M4A1 | 1<<CSW_MAC10 | 1<<CSW_MP5NAVY | 1<<CSW_P90 | 1<<CSW_SCOUT | 1<<CSW_SG550 | 1<<CSW_SG552 | 1<<CSW_TMP | 1<<CSW_UMP45 | 1<<CSW_XM1014)
#define SECONDARY_WEAPONS (1<<CSW_GLOCK18 | 1<<CSW_USP | 1<<CSW_P228 | 1<<CSW_DEAGLE | 1<<CSW_FIVESEVEN | 1<<CSW_ELITE) 


new cvar_weaponsmenu[2], cvar_blockbuyzone[2], cvar_randomweapons, bool:g_roundstarted
public plugin_init()
{
	register_plugin("random weapons", "0.3", "cheap_suit")
	is_biomod_active() ? plugin_init2() : pause("ad")
}

public plugin_init2()
{
	register_logevent("logevent_round_start", 2, "1=Round_Start")
	register_event("HLTV", "event_newround", "a", "1=0", "2=0")
	RegisterHam(Ham_Spawn, "player", "bacon_spawn_post", 1)
	cvar_randomweapons   = register_cvar("bh_randomweapons", "1")
	cvar_weaponsmenu[0]  = get_cvar_pointer("bh_weaponsmenu")
	cvar_blockbuyzone[0] = get_cvar_pointer("bh_blockbuyzone")
}

public plugin_cfg()
{
	cvar_weaponsmenu[1]  = get_pcvar_num(cvar_weaponsmenu[0])
	cvar_blockbuyzone[1] = get_pcvar_num(cvar_blockbuyzone[0])
	set_pcvar_num(cvar_weaponsmenu[0], 0)
	set_pcvar_num(cvar_blockbuyzone[0], 1)
}

public plugin_end()
{
	set_pcvar_num(cvar_weaponsmenu[0], cvar_weaponsmenu[1])
	set_pcvar_num(cvar_blockbuyzone[0], cvar_blockbuyzone[1])
}

public event_newround()
	g_roundstarted = false

public bacon_spawn_post(id) if(is_user_alive(id))
	if(get_pcvar_num(cvar_randomweapons) && g_roundstarted) give_weapons(id)

public logevent_round_start()
{
	if(!get_pcvar_num(cvar_randomweapons)) return
	g_roundstarted = true
	
	static players[32], num, i, id
	get_players(players, num, "a")
	
	for(i = 0; i < num; i++)
	{
		id = players[i]
		if(id != firstzombie()) give_weapons(id)
	}
}

public give_weapons(id)
{
	static weapon, weaponid
	if(!cs_get_user_hasprimary(id))
	{
		weapon = random(charsmax(g_primweaponnames))
		bacon_give_weapon(id, g_primweaponnames[weapon])
			
		weaponid = get_weaponid(g_primweaponnames[weapon])
		cs_set_user_bpammo(id, weaponid, MAX_AMMO)
	}

	if(!cs_get_user_hassecondry(id))
	{
		weapon = random(charsmax(g_secweaponnames))
		bacon_give_weapon(id, g_secweaponnames[weapon])

		weaponid = get_weaponid(g_secweaponnames[weapon])
		cs_set_user_bpammo(id, weaponid, MAX_AMMO)
	}
	
	set_task(0.1, "task_givenades", id)
}

public task_givenades(id)
{
	if(is_user_alive(id)) for(new i = 0; i < sizeof g_grenades; i++)
		bacon_give_weapon(id, g_grenades[i])
}

stock cs_get_user_hasprimary(index) 
{  
	   static weapons[32], num; num = 0     
	   return get_user_weapons(index, weapons, num) & PRIMARY_WEAPONS
}

stock cs_get_user_hassecondry(index) 
{  
	   static weapons[32], num; num = 0     
	   return get_user_weapons(index, weapons, num) & SECONDARY_WEAPONS
}

stock bacon_give_weapon(index, weapon[])
{
	if(!equal(weapon,"weapon_", 7)) return 0

	static ent; ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, weapon))
	if(!pev_valid(ent)) return 0
    
	set_pev(ent, pev_spawnflags, SF_NORESPAWN)
	dllfunc(DLLFunc_Spawn, ent)
   
	if(!ExecuteHamB(Ham_AddPlayerItem, index, any:ent) || !ExecuteHamB(Ham_Item_AttachToPlayer, ent, any:index))
	{
		if(pev_valid(ent)) set_pev(ent, pev_flags, pev(ent, pev_flags) & FL_KILLME)
		return 0
	}
	return 1
}

stock cs_set_user_bpammo(index, weapon, amount)
{
	static offset
	switch(weapon)
	{
		case CSW_AWP:   		     offset = OFFSET_AMMO_AWP
		case CSW_SCOUT, CSW_AK47, CSW_G3SG1: offset = OFFSET_AMMO_SCOUT
		case CSW_M249:  		     offset = OFFSET_AMMO_M249
		case CSW_FAMAS, CSW_M4A1, CSW_AUG, 
		CSW_SG550, CSW_GALI, CSW_SG552:	     offset = OFFSET_AMMO_FAMAS
		case CSW_M3, CSW_XM1014:	     offset = OFFSET_AMMO_M3
		case CSW_USP, CSW_UMP45, CSW_MAC10:  offset = OFFSET_AMMO_USP
		case CSW_FIVESEVEN, CSW_P90:	     offset = OFFSET_AMMO_FIVESEVEN
		case CSW_DEAGLE:		     offset = OFFSET_AMMO_DEAGLE
		case CSW_P228:			     offset = OFFSET_AMMO_P228
		case CSW_GLOCK18, CSW_TMP, CSW_ELITE, 
		CSW_MP5NAVY:			     offset = OFFSET_AMMO_GLOCK18
		default:			     offset = 0
	}
	
	if(offset) set_pdata_int(index, offset, amount)
	
	return 1
}